<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:wadl="http://wadl.dev.java.net/2009/02">
    <xsl:output method="html"/>
    <xsl:variable name="BASE">/symod</xsl:variable>

    <xsl:template match="/">
        <html>
            <body>
                <h1>I N D E X</h1>
                <ul>
                    <xsl:apply-templates
                            select="wadl:application/wadl:resources/wadl:resource[@path='/symod']/wadl:resource"/>
                </ul>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="wadl:resource">
        <xsl:variable name="current" select="."/>
        <xsl:choose>
            <xsl:when
                    test="(following-sibling::wadl:resource | preceding-sibling::wadl:resource)/@path[starts-with(.,concat($current/@path,'/'))]">

            </xsl:when>
            <xsl:when test="contains(@path, '/{')">
                <li>
                    <a>
                        <xsl:variable name="prefix" select="substring-before(@path, '/{')"/>
                        <xsl:attribute name="href">
                            <!-- absolute path -->
                            <!--<xsl:value-of select="/wadl:application/wadl:resources/@base"/>-->
                            <xsl:value-of select="$BASE"/>/<xsl:value-of select="$prefix"/>
                            <xsl:if test="not(preceding-sibling::wadl:resource[@path=$prefix]) and not(following-sibling::wadl:resource[@path=$prefix])">
                                <xsl:text>/_</xsl:text>
                            </xsl:if>
                        </xsl:attribute>
                        <xsl:value-of select="$prefix"/>
                    </a>/{<xsl:value-of select="substring-after(@path, '/{')"/>
                </li>
            </xsl:when>
            <xsl:otherwise>
                <li>
                    <a>
                        <xsl:attribute name="href">
                            <!-- absolute path -->
                            <!--<xsl:value-of select="/wadl:application/wadl:resources/@base"/>-->
                            <xsl:value-of select="$BASE"/>/<xsl:value-of select="@path"/>
                        </xsl:attribute>
                        <xsl:value-of select="@path"/>
                    </a>
                    <xsl:apply-templates select="wadl:method/wadl:request/wadl:param"/>
                </li>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="wadl:param">
        <xsl:choose>
            <xsl:when test="position()=1">?</xsl:when>
            <xsl:otherwise>&amp;</xsl:otherwise>
        </xsl:choose>
        <xsl:value-of select="@name"/>
        <xsl:text>=_</xsl:text>
    </xsl:template>
</xsl:stylesheet>
