#!/bin/sh

HOSTNAME=ccsyre7:8080
#HOSTNAME=symodq.in2p3.fr:18889

INDEX_CACHE_TTL=300
BASE=symod

OPERATION=$1
QUERY=$2
if test -n "$QUERY"; then
    if test -f $QUERY ; then
        INPUT=`cat $QUERY`
    else
        echo "File not found: $QUERY"
        exit 1
    fi
    curl -s -S -H "Content-type: text/xml" --data-urlencode "input=$INPUT" $3 $4 $5 $6 $7 $8 $9 http://$HOSTNAME/$BASE/$OPERATION
elif test -n "$OPERATION"; then
    curl -s -S -H "Content-type: text/xml" http://$HOSTNAME/$BASE/$OPERATION
else
    WADL=/tmp/symod-query.wadl
    if test ! -s $WADL; then
        curl -s -S -H "Content-type: text/xml" http://$HOSTNAME/application.wadl > $WADL
    elif test $((`date +"%s"` - `stat --format="%Z" $WADL`)) -gt $INDEX_CACHE_TTL; then
        curl -s -S -H "Content-type: text/xml" http://$HOSTNAME/application.wadl > $WADL
    fi
    xsltproc ${0%/*}/help.xsl $WADL
fi
