<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:symod="http://www.in2p3.fr/symod" exclude-result-prefixes="symod"
                xmlns="http://www.in2p3.fr/symod">
    <xsl:output method="xml" indent="yes"/>

    <xsl:template match="/symod:query">
        <query>
            <xsl:copy-of select="@* | symod:parsedTime/@*[not(local-name()='order' or local-name()='descending' or local-name()='name')]"/>

            <xsl:copy-of select="symod:description | symod:parsedTime"/>
            <xsl:for-each select="symod:entity[not(descendant::symod:declaration)]">
                <query name="r{position()}">
                    <xsl:apply-templates select="."/>
                </query>
            </xsl:for-each>
            <xsl:copy-of select="symod:global_value"/>
        </query>
    </xsl:template>

    <xsl:template match="symod:entity">
        <xsl:copy-of select="."/>
        <xsl:apply-templates select="/symod:query/symod:entity
            [descendant::symod:declaration/@variable = current()/descendant::symod:variable/text()]"/>
    </xsl:template>
</xsl:stylesheet>
