<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:sql="http://symod.in2p3.fr/sql" exclude-result-prefixes="sql"
                xmlns="http://symod.in2p3.fr/sql">
    <xsl:output method="text"/>
    <xsl:param name="md5">base64_md5_hash</xsl:param>

    <xsl:template match="/sql:query">
        <xsl:variable name="period"><xsl:value-of select="@cacheResolution"/>/1440<xsl:text/></xsl:variable>
        <xsl:variable name="date">
            <xsl:call-template name="DATE">
                <xsl:with-param name="date">sysdate+(ABS(<xsl:value-of select="/sql:query/@plot"/>-1)+1)/2*<xsl:value-of select="$period"/></xsl:with-param>
            </xsl:call-template> - (ABS(<xsl:value-of select="/sql:query/@plot"/>-1)-1)/2*<xsl:value-of select="$period"/>
        </xsl:variable>
<xsl:text/>BEGIN
dbms_scheduler.create_job(
job_name => '"SYMOD_STOCK"."J_<xsl:value-of select="$md5"/>"',
job_type => 'STORED_PROCEDURE',
job_action => '"SYMOD_STOCK"."P_<xsl:value-of select="$md5"/>"',
repeat_interval => 'TRUNC(SYSDATE,''MI'')+<xsl:value-of select="$period"/>',
start_date => <xsl:value-of select="$date"/> + greatest(5/1440, 0.1*<xsl:value-of select="$period"/>),
job_class => '"DEFAULT_JOB_CLASS"',
auto_drop => FALSE,
enabled => FALSE);
dbms_scheduler.set_attribute( name => '"SYMOD_STOCK"."J_<xsl:value-of select="$md5"/>"', attribute => 'logging_level', value => DBMS_SCHEDULER.LOGGING_FAILED_RUNS);
dbms_scheduler.enable( '"SYMOD_STOCK"."J_<xsl:value-of select="$md5"/>"' );
END;<xsl:text/>
    </xsl:template>

    <xsl:template name="DATE">
        <xsl:param name="date"/>
        <xsl:choose>
            <xsl:when test="@resolution and /sql:query/@optimize='false'">
                <xsl:text/>DATE_ROUND(<xsl:value-of select="$date"/>, <xsl:value-of select="@resolution"/>)<xsl:text/>
            </xsl:when>
            <xsl:when test="@resolution">
                <xsl:text/>TO_DATE('1990_01_01','YYYY_MM_DD')+FLOOR(((<xsl:value-of
                    select="$date"/> - TO_DATE('1990_01_01','YYYY_MM_DD'))*1440)/<xsl:value-of
                    select="@resolution"/>)*<xsl:value-of select="@resolution"/>/1440<xsl:text/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$date"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
